<?php

namespace backend\controllers;

use backend\models\MasterSyarat;
use backend\models\MasterSyaratSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * MasterSyaratController implements the CRUD actions for MasterSyarat model.
 */
class MasterSyaratController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all MasterSyarat models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $searchModel = new MasterSyaratSearch();
        $dataProvider = $searchModel->search($this->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single MasterSyarat model.
     * @param int $MASSYA_ID Massya ID
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($MASSYA_ID)
    {
        return $this->render('view', [
            'model' => $this->findModel($MASSYA_ID),
        ]);
    }

    /**
     * Creates a new MasterSyarat model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new MasterSyarat();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'MASSYA_ID' => $model->MASSYA_ID]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing MasterSyarat model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $MASSYA_ID Massya ID
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($MASSYA_ID)
    {
        $model = $this->findModel($MASSYA_ID);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'MASSYA_ID' => $model->MASSYA_ID]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing MasterSyarat model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $MASSYA_ID Massya ID
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($MASSYA_ID)
    {
        $this->findModel($MASSYA_ID)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the MasterSyarat model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $MASSYA_ID Massya ID
     * @return MasterSyarat the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($MASSYA_ID)
    {
        if (($model = MasterSyarat::findOne(['MASSYA_ID' => $MASSYA_ID])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}
